#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <experimental/random>

using namespace std;
using namespace __gnu_pbds;

using str = string;
using ll = long long;
using ld = long double;
using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>;
#define int long long
const ll INF = 1e18, MOD = 1e9 + 7;

void solve();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int q = 1;
    //cin >> q;
    while (q--) {
        solve();
    }
}

vector<int> t;

void update(int v,int l,int r,int ql,int qr,int x) {
    if (ql == l && qr == r) {
        t[v] += x;
    } else {
        int qm = (ql + qr) / 2;
        if (qm >= r) {
            update(2 * v, l, r, ql, qm, x);
        } else if (qm <= l) {
            update(2 * v + 1, l, r, qm, qr, x);
        } else {
            update(2 * v, l, qm, ql, qm, x);
            update(2 * v + 1, qm, r, qm, qr, x);
        }
    }
}

int get(int v,int ql,int qr,int pos) {
    if (qr - ql == 1) {
        return t[v];
    } else {
        int qm = (ql + qr) / 2;
        if (qm > pos) {
            return get(2 * v, ql, qm, pos) + t[v];
        } else {
            return get(2 * v + 1, qm, qr, pos) + t[v];
        }
    }
}

void solve() {
    int n;
    cin >> n;
    t.resize(4 * n + 5);
    vector<int> h(n);
    for (int i = 0; i < n; ++i) {
        cin >> h[i];
    }
    ordered_set t;
    for (int i = 0; i < n; ++i) {
        t.insert(i);
    }
    vector<vector<pair<int,int> > > que(n);
    t.insert(n);
    for (int i = 0; i < n - 1; ++i) {
        int k;
        cin >> k;
        int l = -1;
        int r = n;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (t.order_of_key(m + 1) >= k) {
                r = m;
            } else {
                l = m;
            }
        }
        auto x = *t.upper_bound(r);
        auto x1 = *t.upper_bound(x);
        t.erase(x);
        que[x1 - 1].push_back({r, i});
    }
    vector<int> ans(n - 1);
    vector<pair<int,int> > mx;
    for (int i = 0; i < n; ++i) {
        bool p = false;
        int w = -1;
        while (mx.size() > 0 && mx[mx.size() - 1].first < h[i]) {
            if (p) {
                update(1, 0, mx[mx.size() - 1].second + 1, 0, n,
                       (mx[mx.size() - 1].first - w) * (i - mx[mx.size() - 1].second - 1));
            }
            p = true;
            w = mx[mx.size() - 1].first;
            mx.pop_back();
        }
        if (mx.size() > 0 && p) {
            update(1, 0, mx[mx.size() - 1].second + 1, 0, n, (h[i] - w) * (i - mx[mx.size() - 1].second - 1));
        }
        mx.push_back({h[i], i});
        for (auto to: que[i]) {
            ans[to.second] = get(1, 0, n, to.first);
        }
    }
    for (int i = 0; i < n - 1; ++i) {
        cout << ans[i] << " ";
    }
}
