#include <bits/stdc++.h>
#include <experimental/random>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
using str = string;
using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>;
const ll INF = 1e18, MOD = 1e9 + 7;

#define int long long

void solve();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int q = 1;
    //cin >> q;
    while (q--) {
        solve();
    }
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n + 2);
    for (int i = 0; i < n; i++) {
        cin >> a[i + 1];
    }
    vector<int> pr(n + 2);
    vector<int> prmn(n + 2);
    vector<int> sufmn(n + 2);
    prmn[0] = INF;
    for (int i = 1; i <= n; i++) {
        pr[i] = pr[i - 1] + a[i];
        prmn[i] = min(prmn[i - 1], a[i]);
    }
    sufmn[n + 1] = INF;
    for (int i = n; i >= 1; i--) {
        sufmn[i] = min(sufmn[i + 1], a[i]);
    }
    int ans = 0;
    k = n - k + 1;
    while (k >= 1) {
        for (int i = k; i <= n; i++) {
            ans = max(ans, pr[i] - pr[i - k] - min(prmn[i - k], sufmn[i + 1]));
        }
        k--;
    }
    cout << ans;
}
