#include <bits/stdc++.h>
#include <experimental/random>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
using str = string;
using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>;
const ll INF = 1e18, MOD = 1e9 + 7;

#define int long long

void solve();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int q = 1;
    //cin >> q;
    while (q--) {
        solve();
    }
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n + 2);
    for (int i = 0; i < n; i++) {
        cin >> a[i + 1];
    }
    vector<int> pr(n + 2);
    vector<int> prmn(n + 2);
    vector<int> sufmn(n + 2);
    prmn[0] = INF;
    for (int i = 1; i <= n; i++) {
        pr[i] = pr[i - 1] + a[i];
        prmn[i] = min(prmn[i - 1], a[i]);
    }
    sufmn[n + 1] = INF;
    for (int i = n; i >= 1; i--) {
        sufmn[i] = min(sufmn[i + 1], a[i]);
    }
    k = n - k + 1;
    vector<int> ans(n + 2);
    int mx = -1;
    for (int i = 1; i <= n; i++) {
        if (i == k + 1) {
            mx = max(mx, pr[i - 1] - pr[i - 1 - k]);
            ans[i] = max(ans[i], mx);
        } else if (mx != -1) {
            mx = max(mx, pr[i - 1] - pr[i - 1 - k]);
            ans[i] = max(ans[i], mx);
        } else {
            ans[i] = max(ans[i], pr[i - 1] - pr[0]);
        }
    }
    mx = -1;
    for (int i = n; i >= 1; --i) {
        if (i == n - k) {
            mx = max(mx, pr[i + k] - pr[i]);
        }
        if (mx != -1) {
            mx = max(mx, pr[i + k] - pr[i]);
            ans[i] = max(ans[i], mx);
        } else {
            ans[i] = max(ans[i], pr[n] - pr[i]);
        }
    }
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        cnt = max(cnt, ans[i] - a[i]);
    }
    cout << cnt;
}
