#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <experimental/random>
#pragma GCC optimize("Ofast")
#pragma GCC optimize("O2")
#pragma GCC optimize("unroll-loops")
using namespace std;
using namespace __gnu_pbds;

using str = string;
using ll = long long;
using ld = long double;
using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>;
const ll INF = 1e18, MOD = 1e9 + 7;

void solve();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int q = 1;
    //cin >> q;
    while (q--) {
        solve();
    }
}

int k;
int kk;

inline int get(vector<int> u) {
    int sum = 0;
    int kk1 = 1;
    for (int i = 0; i < u.size(); i++) {
        sum += u[i] * kk1;
        kk1 *= kk;
    }
    return sum;
}

inline int get1(vector<int> u) {
    int sum = 0;
    int kk1 = 1;
    for (int i = 1; i < u.size(); i++) {
        sum += u[i] * kk1;
        kk1 *= kk;
    }
    return sum;
}

inline vector<int> def(int sum) {
    vector<int> u(k - 1);
    for (int i = 0; i < k - 1; i++) {
        u[i] = sum % kk;
        sum /= kk;
    }
    return u;
}

void solve() {
    int n;
    cin >> n >> k;
    kk = k * k;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    unordered_map<int, int> dp;
    vector<int> u(k - 1);
    dp[get(u)]++;
    vector<int> st(k + 1);
    st[0] = 1;
    for (int i = 1; i <= k; i++) {
        st[i] = st[i - 1] * 2;
    }
    for (int i = 0; i < n; i++) {
        unordered_map<int, int> dp1;
        for (int j = 0; j < st[k]; j++) {
            vector<int> d(k);
            for (int g = 0; g < k; g++) {
                if ((j >> g) % 2 == 1) {
                    for (int cur = 0; cur < k - g; cur++) {
                        d[cur]++;
                    }
                }
            }
            for (auto e: dp) {
                vector<int> t = def(e.first);
                if ((t.size() == 0 && d[0] == a[i]) || (t.size() > 0 && t[0] + d[0] == a[i])) {
                    t.push_back(0);
                    for (int g = 0; g < k; g++) {
                        t[g] += d[g];
                    }
                    int dd = get1(t);
                    dp1[dd] += e.second;
                    dp1[dd] %= MOD;
                }
            }
        }
        swap(dp, dp1);
    }
    int cnt = 0;
    for (auto e: dp) {
        cnt += e.second;
        cnt %= MOD;
    }
    cout << cnt << endl;
}
