#include <bits/stdc++.h>
#include <experimental/random>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
using str = string;
using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>;
const ll INF = 1e18, MOD = 1e9 + 7;

#define int long long

void solve();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int q = 1;
    //cin >> q;
    while (q--) {
        solve();
    }
}

struct f {
    int from, day, pos;
};

void solve() {
    int n, s;
    cin >> n >> s;
    vector<vector<f> > q(n + 1, vector<f>(s + 1, {-2, -1, -1}));
    q[0][0] = {-1, 0, 0};
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        int k1 = k;
        while (k--) {
            int c;
            cin >> c;
            for (int j = s - c; j >= 0; --j) {
                if (q[i][j].from != -2) {
                    q[i + 1][j + c] = {j, i, k1 - k};
                }
            }
        }
    }
    if (q[n][s].from != -2) {
        cout << "YES\n";
        int cur = s;
        int cur2 = n;
        vector<vector<int> > ans(n);
        while (cur2 != 0) {
            ans[q[cur2][cur].day].push_back(q[cur2][cur].pos);
            cur = q[cur2][cur].from;
            cur2--;
        }
        for (int i = 0; i < n; ++i) {
            cout << ans[i].size() << "\n";
            for (int j = 0; j < ans[i].size(); ++j) {
                cout << ans[i][j] << " ";
            }
            cout << "\n";
        }
    } else {
        cout << "NO\n";
    }
}
