#include <bits/stdc++.h>
#include <experimental/random>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
using str = string;
using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>;
const ll INF = 1e18, MOD = 1e9 + 7;

#define int long long

void solve();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int q = 1;
    //cin >> q;
    while (q--) {
        solve();
    }
}

int n, m, k;
vector<vector<int> > pos;
int ans = 0;

void rec(int x,int y, set<pair<int,int> > d, vector<int> u) {
    if (x == n - 1 && y == m - 1) {
        int cur = 0;
        vector<int> t(m);
        for (int i = 0; i < m; ++i) {
            cur += u[i];
            t[i] = cur;
        }
        int cnt = 0;
        for (int i = 0; i < m; ++i) {
            for (int j = 0; j <= t[i]; ++j) {
                cnt += pos[j][i];
            }
        }
        for (auto x: d) {
            cnt -= pos[x.first][x.second];
        }
        if (cnt == 0) {
            vector<pair<int,int> > w;
            for (int i = 0; i < m; ++i) {
                for (int j = t[i] + 1; j < n; ++j) {
                    if (pos[j][i] == 1) {
                        w.push_back({j, i});
                    }
                }
            }
            w.push_back({0, 0});
            w.push_back({n - 1, m - 1});
            sort(w.begin(), w.end());
            vector<vector<int> > dp(n, vector<int>(m));
            int cnt1 = 1;
            for (int i = 0; i < w.size() - 1; ++i) {
                if (w[i].first > w[i + 1].first || w[i].second > w[i + 1].second) {
                    cnt1 = 0;
                } else {
                    dp[w[i].first][w[i].second] = 1;
                    for (x = w[i].first; x <= w[i + 1].first; ++x) {
                        for (y = w[i].second; y <= w[i + 1].second; ++y) {
                            if (x > w[i].first) {
                                dp[x][y] += dp[x - 1][y];
                            }
                            if (y > w[i].second) {
                                dp[x][y] += dp[x][y - 1];
                            }
                            dp[x][y] %= MOD;
                            if (y == 0) {
                            } else if (y == m - 1) {
                                if (x != n - 1) {
                                    dp[x][y] = 0;
                                }
                            } else if (t[y] >= x) {
                                dp[x][y] = 0;
                            }
                        }
                    }
                    cnt1 *= dp[w[i + 1].first][w[i + 1].second];
                    cnt1 %= MOD;
                }
            }
            ans += cnt1;
            ans %= MOD;
        }
    } else {
        if (y != m - 1) {
            y++;
            d.insert({x, y});
            rec(x, y, d, u);
            d.erase({x, y});
            y--;
        }
        if (x != n - 1 && y != 0) {
            x++;
            d.insert({x, y});
            u[y]++;
            rec(x, y, d, u);
            d.erase({x, y});
            x--;
            u[y]--;
        }
    }
}

void solve() {
    int k;
    cin >> n >> m >> k;
    pos.resize(n, vector<int>(m));
    for (int i = 0; i < k; ++i) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        pos[x][y] = 1;
    }
    vector<int> u(m);
    set<pair<int,int> > d;
    d.insert({0, 0});
    rec(0, 0, d, u);
    cout << ans*2 << '\n';
}