#include <bits/stdc++.h>
#include <experimental/random>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
using str = string;
using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>;
const ll INF = 1e18, MOD = 1e9 + 7;

#define int long long

void solve();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int q = 1;
    //cin >> q;
    while (q--) {
        solve();
    }
}

void solve() {
    int n, m, k;
    cin >> n >> m >> k;
    map<vector<int>, pair<int,int> > dp;
    vector<vector<bool> > col(n, vector<bool>(m, false));
    int k1 = 0;
    for (int i = 0; i < k; i++) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        if (x == 0 && y == 0) {
            continue;
        }
        if (x == n - 1 && y == m - 1) {
            continue;
        }
        col[x][y] = true;
        k1++;
    }
    swap(k, k1);
    for (int x1 = 0; x1 < n - 1; ++x1) {
        for (int y1 = 0; y1 < m - 1; ++y1) {
            for (int x2 = 0; x2 < n - 1; ++x2) {
                int y2 = x1 + y1 - x2;
                if (y2 >= 0 && y2 < m - 1) {
                    vector<pair<int,int> > t;
                    if (x1 > 0 && x2 > 0) {
                        t.push_back({dp[{x1 - 1, y1, x2 - 1, y2}]});
                    }
                    if (x1 > 0 && y2 > 0) {
                        t.push_back({dp[{x1 - 1, y1, x2, y2 - 1}]});
                    }
                    if (y1 > 0 && x2 > 0) {
                        t.push_back({dp[{x1, y1 - 1, x2 - 1, y2}]});
                    }
                    if (y1 > 0 && y2 > 0) {
                        t.push_back({dp[{x1, y1 - 1, x2, y2 - 1}]});
                    }
                    int mx = -1;
                    int cnt = 0;
                    for (auto dd: t) {
                        if (dd.first > mx) {
                            mx = dd.first;
                            cnt = dd.second;
                        } else {
                            cnt += dd.second;
                        }
                    }
                    if (mx == -1) {
                        dp[{x1, y1, x2, y2}] = {col[x1 + 1][y1] + col[x2][y2 + 1], 1};
                    } else {
                        dp[{x1, y1, x2, y2}] = {col[x1 + 1][y1] + col[x2][y2 + 1] + mx, cnt};
                    }
                }
            }
        }
    }
    n--;
    m--;
    if (dp[{n - 1, m - 1, n - 1, m - 1}].first >= k) {
        cout << dp[{n - 1, m - 1, n - 1, m - 1}].second;
    } else {
        cout << 0;
    }
}
